/*
 * spi.c
 *
 * Created: 13.12.2014 17:02:46
 *  Author: Moataz
 */ 
#include "spi.h"

void spiInit(void)
{
	DDRB = (1<<AD7734_RESET)|(1<<AD7734_P0)|(1<<AD7734_SYNC)|(1<<SPI_MOSI)|(1<<SPI_SCK);
	DDRA = (1<<AD7734_CS);
	PORTB |= (1<<AD7734_RESET);
	PORTA &= ~(1<<AD7734_CS);
	SPCR = (1<<SPE)|(1<<MSTR)|(1<<SPR0)|(1<<CPOL)|(1<<CPHA);
}

void spiWriteByte(uint8_t Byte_u8)
{
	SPDR = Byte_u8;
	while(!(SPSR & (1<<SPIF)));
}

uint8_t spiReadByte(uint8_t address_u8)
{
	uint8_t byteRead_u8=0;
	SPDR = address_u8;
	while(!(SPSR & (1<<SPIF)));
	byteRead_u8=SPDR;
	return byteRead_u8;
}






void spiWriteData(uint8_t *data_u8a, uint8_t byteNumber_u8)
{
	uint8_t writeData[4]	= {0, 0, 0, 0};
	uint8_t readData[4]		= {0, 0, 0, 0};
	uint8_t i_u8 = 0;
	
	//PORTB &= ~(1<<AD7734_CS);
	for(i_u8 = 0;i_u8 < byteNumber_u8;i_u8 ++)
	{
		spiWriteByte(data_u8a[i_u8]);
	}
	//PORTB |= (1<<AD7734_CS);
}

void spiReadData(uint8_t *data_u8a, uint8_t byteNumber_u8)
{
	uint8_t i_u8;
	//PORTB &= ~(1<<AD7734_CS);
	for (i_u8 = 0; i_u8 < byteNumber_u8 ; i_u8++)
	{
		data_u8a[i_u8] = spiReadByte(0xff);
	}
	//PORTB |= (1<<AD7734_CS);
}
